package generated.ageVerification.javacard.ePa;

import javacard.framework.*;

/**
 * Generated Class
 * 
 */

public class SigBackData implements SignData, Codeable {

	public Nonce Nonce1;

	public Nonce Nonce2;

	public short age;

	public byte[] answer;

	public SigBackData() {

		Nonce1 = new Nonce();
		Nonce2 = new Nonce();
		age = 0;
		answer = new byte[Store.LENGTHOFSTRING];

	}

	public SigBackData(Nonce Nonce1, Nonce Nonce2, short age, byte[] answer) {

		this.Nonce1 = Nonce1;
		this.Nonce2 = Nonce2;
		this.age = age;
		this.answer = answer;

	}

	public byte getCode() {
		return Code.SIGBACKDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(SigBackData other) {
		if (!this.Nonce1.equals(other.Nonce1))
			return false;
		if (!this.Nonce2.equals(other.Nonce2))
			return false;
		if (this.age != other.age)
			return false;
		if (!Arrays.equals(answer, other.answer))
			return false;
		return true;
	}

	public void copy(SigBackData from) {
		this.Nonce1.copy(from.Nonce1);
		this.Nonce2.copy(from.Nonce2);
		this.age = from.age;

		Arrays.copy(from.answer, this.answer);

	}

}
