package generated.ageVerification.terminal.terminal;

import java.security.SecureRandom;
import swt.util.ByteArray;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;
@XmlAccessorType(XmlAccessType.FIELD)
public class Nonce implements Codeable, SignData {

	private byte[] nonce;

	@XmlTransient
	private SecureRandom rd;

	public Nonce() {

		nonce = new byte[LengthConstants.LENGTHOFNONCE];
		rd = new SecureRandom();
	}

	public byte[] getNonce() {

		return nonce;
	}

	public void setNonce(byte[] nonce) {
		ByteArray.copy(nonce, (short) 0, this.nonce, (short) 0,
				(short) this.nonce.length);
	}

	public void copy(Nonce o) {

		nonce = o.getNonce().clone();
	}

	public byte getCode() {
		return Code.NONCE;
	}

	public boolean equals(Nonce other) {
		return Arrays.equals(nonce, other.nonce);
	}

	public static Nonce generateNonce() {
		return (new Nonce()).instGenerateNonce();
	}

	public Nonce instGenerateNonce() {

		rd.nextBytes(nonce);
		return this;
	}

}
