package generated.ageVerification.terminal.terminal;

/**
 * Generated Class
 * 
 */

public class SigBackData implements SignData, Codeable {

	private Nonce Nonce1;

	private Nonce Nonce2;

	private int age;

	private String answer;

	public SigBackData() {

		Nonce1 = new Nonce();
		Nonce2 = new Nonce();
		age = 0;
		answer = new String();

	}

	public SigBackData(Nonce Nonce1, Nonce Nonce2, int age, String answer) {

		this.Nonce1 = Nonce1;
		this.Nonce2 = Nonce2;
		this.age = age;
		this.answer = answer;

	}

	public SigBackData(Nonce Nonce1, Nonce Nonce2, int age, byte[] answer) {
		this.Nonce1 = Nonce1;
		this.Nonce2 = Nonce2;
		this.age = age;
		this.answer = Coding.getInstance().byteToString(answer);

	}

	public Nonce getNonce1() {
		return Nonce1;
	}

	public Nonce getNonce2() {
		return Nonce2;
	}

	public int getAge() {
		return age;
	}

	public String getAnswer() {
		return answer;
	}

	public void setNonce1(Nonce Nonce1) {
		this.Nonce1 = Nonce1;
	}
	public void setNonce2(Nonce Nonce2) {
		this.Nonce2 = Nonce2;
	}
	public void setAge(int age) {
		this.age = age;
	}

	public void setAnswer(String answer) {

		if (!Coding.getInstance().isValidCardString(answer))
			System.err.println("Encoded string " + answer + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.answer = answer;
	}
	public void setAnswer(byte[] answer) {
		setAnswer(Coding.getInstance().byteToString(answer));
	}

	public byte getCode() {
		return Code.SIGBACKDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(SigBackData other) {
		if (!this.Nonce1.equals(other.Nonce1))
			return false;
		if (!this.Nonce2.equals(other.Nonce2))
			return false;
		if (this.age != other.age)
			return false;
		if (!this.answer.equals(other.answer))
			return false;
		return true;
	}

	public void copy(SigBackData from) {
		this.Nonce1.copy(from.Nonce1);
		this.Nonce2.copy(from.Nonce2);
		this.age = from.age;
		this.answer = from.answer;
	}

	public SigBackData copy() {
		SigBackData object = new SigBackData();
		object.copy(this);
		return object;
	}

}
