package generated.ageVerification.javacard.ePa;

import javacard.framework.APDU;

public interface Gate {

	/**
	 * Assertion function for gate constraints
	 */
	public void callConstraints();

	/**
	 * Sends an APDU originating from card. Write redirection code here.
	 * @param card SimpleComm card which requested the send action
	 * @param apdu APDU to be sent
	 * @param remLen remaining length to be sent
	 */
	public void sendAPDU(SimpleComm card, APDU apdu, byte[] data, short remLen,
			boolean first);

	/**
	 * Called when the original protocol is finished
	 */
	public void finishProtocol(SimpleComm card);
}
