package generated.ageVerification.javacard.ePa;

public class Store {

	public final static short LENGTHOFSTRING = 20;
	public final static short LENGTHOFSECRET = 8;
	public final static short LENGTHOFNONCE = 8;
	public final static short MAXSIGNEDLENGTH = 128;
	public final static short MaxEncodingLengthSignData = 156;
	public final static short sigMaxCountForEPa = 1;
	public final static short sigBackMaxCountForEPa = 1;
	public final static short sendNonceMaxCountForEPa = 1;
	public final static short NonceMaxCountForEPa = 1;
	public final static short SignedDataMaxCountForEPa = 1;
	public final static short SigBackDataMaxCountForEPa = 1;
	public final static short sendCertMaxCountForEPa = 1;

	// ************************************************
	private static sig[] sigArray;
	private static byte sigCount = 0;
	private static void initsig() {
		sigArray = new sig[sigMaxCountForEPa];
		for (short i = 0; i < sigArray.length; i++)
			sigArray[i] = new sig();
	}
	public static sig newsig() {
		return sigArray[sigCount++];
	}

	// ************************************************
	private static sigBack[] sigBackArray;
	private static byte sigBackCount = 0;
	private static void initsigBack() {
		sigBackArray = new sigBack[sigBackMaxCountForEPa];
		for (short i = 0; i < sigBackArray.length; i++)
			sigBackArray[i] = new sigBack();
	}
	public static sigBack newsigBack() {
		return sigBackArray[sigBackCount++];
	}

	// ************************************************
	private static sendNonce[] sendNonceArray;
	private static byte sendNonceCount = 0;
	private static void initsendNonce() {
		sendNonceArray = new sendNonce[sendNonceMaxCountForEPa];
		for (short i = 0; i < sendNonceArray.length; i++)
			sendNonceArray[i] = new sendNonce();
	}
	public static sendNonce newsendNonce() {
		return sendNonceArray[sendNonceCount++];
	}

	// ************************************************
	private static Nonce[] NonceArray;
	private static byte NonceCount = 0;
	private static void initNonce() {
		NonceArray = new Nonce[NonceMaxCountForEPa];
		for (short i = 0; i < NonceArray.length; i++)
			NonceArray[i] = new Nonce();
	}
	public static Nonce newNonce() {
		return NonceArray[NonceCount++];
	}

	// ************************************************
	private static SignedData[] SignedDataArray;
	private static byte SignedDataCount = 0;
	private static void initSignedData() {
		SignedDataArray = new SignedData[SignedDataMaxCountForEPa];
		for (short i = 0; i < SignedDataArray.length; i++)
			SignedDataArray[i] = new SignedData();
	}
	public static SignedData newSignedData() {
		return SignedDataArray[SignedDataCount++];
	}

	// ************************************************
	private static SigBackData[] SigBackDataArray;
	private static byte SigBackDataCount = 0;
	private static void initSigBackData() {
		SigBackDataArray = new SigBackData[SigBackDataMaxCountForEPa];
		for (short i = 0; i < SigBackDataArray.length; i++)
			SigBackDataArray[i] = new SigBackData();
	}
	public static SigBackData newSigBackData() {
		return SigBackDataArray[SigBackDataCount++];
	}

	// ************************************************
	private static sendCert[] sendCertArray;
	private static byte sendCertCount = 0;
	private static void initsendCert() {
		sendCertArray = new sendCert[sendCertMaxCountForEPa];
		for (short i = 0; i < sendCertArray.length; i++)
			sendCertArray[i] = new sendCert();
	}
	public static sendCert newsendCert() {
		return sendCertArray[sendCertCount++];
	}

	// ************************************************
	public static sig newsig(SigData data, SignedData sig) {
		sig _sig = newsig();
		//Attributes with complex types: Use copy-method of these types.
		_sig.data.copy(data);
		//Attributes with complex types: Use copy-method of these types.
		_sig.sig.copy(sig);
		return _sig;
	}

	// ************************************************
	public static sigBack newsigBack(SigBackData data, SignedData sig,
			Certificate EPaCert) {
		sigBack _sigBack = newsigBack();
		//Attributes with complex types: Use copy-method of these types.
		_sigBack.data.copy(data);
		//Attributes with complex types: Use copy-method of these types.
		_sigBack.EPaCert.copy(EPaCert);
		//Attributes with complex types: Use copy-method of these types.
		_sigBack.sig.copy(sig);
		return _sigBack;
	}

	// ************************************************
	public static sendNonce newsendNonce(Nonce Nonce2) {
		sendNonce _sendNonce = newsendNonce();
		//Attributes with complex types: Use copy-method of these types.
		_sendNonce.Nonce2.copy(Nonce2);
		return _sendNonce;
	}

	// ************************************************
	public static Nonce newNonce(byte[] nonce) {
		Nonce _Nonce = newNonce();
		//The type of nonce is an array of primitive Types.
		Arrays.copy(nonce, _Nonce.nonce);
		return _Nonce;
	}

	// ************************************************
	public static SignedData newSignedData(byte[] signed) {
		SignedData _SignedData = newSignedData();
		//The type of signed is an array of primitive Types.
		Arrays.copy(signed, _SignedData.signed);
		return _SignedData;
	}

	// ************************************************
	public static SigBackData newSigBackData(Nonce Nonce1, Nonce Nonce2,
			short age, byte[] answer) {
		SigBackData _SigBackData = newSigBackData();
		//Attributes with complex types: Use copy-method of these types.
		_SigBackData.Nonce1.copy(Nonce1);
		//Attributes with complex types: Use copy-method of these types.
		_SigBackData.Nonce2.copy(Nonce2);
		//The type of age is primitive: do a simple assignment
		_SigBackData.age = age;
		//The type of answer is an array of primitive Types.
		Arrays.copy(answer, _SigBackData.answer);
		return _SigBackData;
	}

	// ************************************************
	public static sendCert newsendCert(Nonce Nonce1, Certificate TCert) {
		sendCert _sendCert = newsendCert();
		//Attributes with complex types: Use copy-method of these types.
		_sendCert.Nonce1.copy(Nonce1);
		//Attributes with complex types: Use copy-method of these types.
		_sendCert.TCert.copy(TCert);
		return _sendCert;
	}

	// initialize all: fill arrays
	public static void initAll() {

		initsig();

		initsigBack();

		initsendNonce();

		initNonce();

		initSignedData();

		initSigBackData();

		initsendCert();
	}

	public static void reset() {

		sigCount = 0;

		sigBackCount = 0;

		sendNonceCount = 0;

		NonceCount = 0;

		SignedDataCount = 0;

		SigBackDataCount = 0;

		sendCertCount = 0;
	}
}
