package generated.ageVerification.terminal.terminal;

/**
 * Generated Class
 * 
 */

public class CertData implements SignData, Codeable {

	private String Name;

	private PublicKey PublicKey;

	public CertData() {

		Name = new String();
		PublicKey = new PublicKey();

	}

	public CertData(String Name, PublicKey PublicKey) {

		this.Name = Name;
		this.PublicKey = PublicKey;

	}

	public CertData(byte[] Name, PublicKey PublicKey) {
		this.Name = Coding.getInstance().byteToString(Name);
		this.PublicKey = PublicKey;

	}

	public String getName() {
		return Name;
	}

	public PublicKey getPublicKey() {
		return PublicKey;
	}

	public void setName(String Name) {

		if (!Coding.getInstance().isValidCardString(Name))
			System.err.println("Encoded string " + Name + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.Name = Name;
	}
	public void setName(byte[] Name) {
		setName(Coding.getInstance().byteToString(Name));
	}

	public void setPublicKey(PublicKey PublicKey) {
		this.PublicKey = PublicKey;
	}

	public byte getCode() {
		return Code.CERTDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(CertData other) {
		if (!this.Name.equals(other.Name))
			return false;
		if (!this.PublicKey.equals(other.PublicKey))
			return false;
		return true;
	}

	public void copy(CertData from) {
		this.Name = from.Name;
		this.PublicKey.copy(from.PublicKey);
	}

	public CertData copy() {
		CertData object = new CertData();
		object.copy(this);
		return object;
	}

}
