package generated.ageVerification.terminal.terminal;

/**
 * Generated Class
 * 
 */

public class Certificate implements Codeable {

	private CertData data;

	private SignedData sig;

	public Certificate(CertData data, SignedData sig) {

		this.data = data;
		this.sig = sig;

	}

	public Certificate() {

		data = new CertData();
		sig = new SignedData();

	}

	public CertData getData() {
		return data;
	}

	public SignedData getSig() {
		return sig;
	}

	public void setData(CertData data) {
		this.data = data;
	}
	public void setSig(SignedData sig) {
		this.sig = sig;
	}

	public byte getCode() {
		return Code.CERTIFICATE;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(Certificate other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.sig.equals(other.sig))
			return false;
		return true;
	}

	public void copy(Certificate from) {
		this.data.copy(from.data);
		this.sig.copy(from.sig);
	}

	public Certificate copy() {
		Certificate object = new Certificate();
		object.copy(this);
		return object;
	}

}
