package generated.ageVerification.terminal.terminal;

/**
 * Generated Class
 * 
 */

public class SigData implements SignData, Codeable {

	private Nonce Nonce1;

	private Nonce Nonce2;

	private int age;

	private Date Datum;

	public SigData() {

		Nonce1 = new Nonce();
		Nonce2 = new Nonce();
		age = 0;
		Datum = new Date();

	}

	public SigData(Nonce Nonce1, Nonce Nonce2, int age, Date Datum) {

		this.Nonce1 = Nonce1;
		this.Nonce2 = Nonce2;
		this.age = age;
		this.Datum = Datum;

	}

	public Nonce getNonce1() {
		return Nonce1;
	}

	public Nonce getNonce2() {
		return Nonce2;
	}

	public int getAge() {
		return age;
	}

	public Date getDatum() {
		return Datum;
	}

	public void setNonce1(Nonce Nonce1) {
		this.Nonce1 = Nonce1;
	}
	public void setNonce2(Nonce Nonce2) {
		this.Nonce2 = Nonce2;
	}
	public void setAge(int age) {
		this.age = age;
	}

	public void setDatum(Date Datum) {
		this.Datum = Datum;
	}

	public byte getCode() {
		return Code.SIGDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(SigData other) {
		if (!this.Nonce1.equals(other.Nonce1))
			return false;
		if (!this.Nonce2.equals(other.Nonce2))
			return false;
		if (this.age != other.age)
			return false;
		if (!this.Datum.equals(other.Datum))
			return false;
		return true;
	}

	public void copy(SigData from) {
		this.Nonce1.copy(from.Nonce1);
		this.Nonce2.copy(from.Nonce2);
		this.age = from.age;
		this.Datum.copy(from.Datum);
	}

	public SigData copy() {
		SigData object = new SigData();
		object.copy(this);
		return object;
	}

}
